/*****************************************************************/
/*  ELEC 999                                                     */
/*  University of Nebraska-Lincoln                               */
/*  Department of Electrical Engineering                         */
/*  David J. Russell                                             */
/*  3-5-10                                                       */
/*****************************************************************/

#ifdef _CLUSTERADT
#define CLUSTERADT_EXTERN
#else
#define CLUSTERADT_EXTERN extern
#endif

/******************************************************************/
/* Public Module Constants                                        */
/******************************************************************/

/******************************************************************/
/* Public Type Definitions                                        */
/******************************************************************/
typedef struct
{
   UBYTE NumberOfBasesAllocated;
   ULONG NumberOfSequencesAllocated;

   BOOLEAN MarkedAsCompleteBasis;
      
   UBYTE NumberOfBases;
   ULONG NumberOfSequences;
   MATRIXULONGADT_MATRIX_TYPE SequenceIndicies;

   STLADT_TREELIST_TYPE Sequences;
   MATRIXDOUBLEADT_MATRIX_TYPE SequenceDictionaries;

   MATRIXULONGADT_MATRIX_TYPE BasisSequenceIndicies;

   MATRIXDOUBLEADT_MATRIX_TYPE DistanceVectors;

   ULONG RepresentationIndex;
   STADT_TREE_TYPE *RepresentationSequence;
   DOUBLE RepresentationDictionary;

} CLUSTERADT_CLUSTER_TYPE;

/*********************************************************************************/
/* Public Module Variables */
/*********************************************************************************/

/*********************************************************************************/
/* Public Module Function Prototypes */
/*********************************************************************************/

void CLUSTERADT_InitializeCluster(CLUSTERADT_CLUSTER_TYPE *Cluster, 
                                    STADT_TREE_TYPE *Sequence,
                                    ULONG SequenceIndex,
                                    FLOAT DictionarySize,
                                    UBYTE MaxNumberBasisSequences);
void CLUSTERADT_CleanUpCluster(CLUSTERADT_CLUSTER_TYPE *Cluster);
void CLUSTERADT_AddSequenceIncompleteBasis(CLUSTERADT_CLUSTER_TYPE *Cluster, 
                                             STADT_TREE_TYPE *Sequence,
                                             ULONG SequenceIndex,
                                             FLOAT DictionarySize,
                                             BOOLEAN AddNewBasis);
void CLUSTERADT_AddSequenceCompleteBasis(CLUSTERADT_CLUSTER_TYPE *Cluster, 
                                          STADT_TREE_TYPE *Sequence,
                                          ULONG SequenceIndex,
                                          FLOAT DictionarySize);
void CLUSTERADT_SetClusterAsCompleteBasis(CLUSTERADT_CLUSTER_TYPE *Cluster);
