/*****************************************************************/
/*  ELEC 999                                                     */
/*  University of Nebraska-Lincoln                               */
/*  Department of Electrical Engineering                         */
/*  David J. Russell                                             */
/*  3-5-10                                                       */
/*****************************************************************/

#define _CLUSTERLISTADT

/*********************************************************************************/
/* Included Header Files */
/*********************************************************************************/
#include "Globals.h"
#include "MatrixUlongADT.h"
#include "MatrixDoubleADT.h"
#include "StringADT.h"
#include "SuffixTreeADT.h"
#include "SuffixTreeListADT.h"
#include "ClusterADT.h"
#include "ClusterListADT.h"

/*********************************************************************************/
/* Private Module Constants */
/*********************************************************************************/

/*********************************************************************************/
/* Private Type Definitions */
/*********************************************************************************/

/*********************************************************************************/
/* Private Module Function Prototypes */
/*********************************************************************************/

/*********************************************************************************/
/* Private Module Variables */
/*********************************************************************************/

/*********************************************************************************/
/* Public and Private Module Functions */
/*********************************************************************************/

void CLUSTERLISTADT_InitializeClusterList(CLUSTERLISTADT_CLUSTERLIST_TYPE *ClusterList)
{
   ClusterList->NumberOfClusters = 0;
   ClusterList->Clusters = NULL;
}

/*********************************************************************************/

void CLUSTERLISTADT_CleanUpClusterList(CLUSTERLISTADT_CLUSTERLIST_TYPE *ClusterList)
{
   ULONG i;

   for (i = 0; i < ClusterList->NumberOfClusters; i++)
   {
      CLUSTERADT_CleanUpCluster(&(ClusterList->Clusters[i]));
   }

   ClusterList->NumberOfClusters = 0;
   ClusterList->Clusters = NULL;
}

/*********************************************************************************/

void CLUSTERLISTADT_AppendNewClusterToClusterList(CLUSTERLISTADT_CLUSTERLIST_TYPE *ClusterList, 
                                                   STADT_TREE_TYPE *Sequence,
                                                   ULONG SequenceIndex,
                                                   FLOAT DictionarySize,
                                                   UBYTE MaxNumberBasisSequences)
{
   if (ClusterList->NumberOfClusters == 0)
   {
      ClusterList->Clusters = (CLUSTERADT_CLUSTER_TYPE *) malloc(sizeof(CLUSTERADT_CLUSTER_TYPE));
      if (ClusterList->Clusters == NULL)
      {
         printf("Error: malloc failed in CLUSTERLISTADT_AppendClusterToClusterList.\n");
         exit(1);
      }
   }
   else
   {
      ClusterList->Clusters = (CLUSTERADT_CLUSTER_TYPE *) realloc(ClusterList->Clusters, sizeof(CLUSTERADT_CLUSTER_TYPE) * (ClusterList->NumberOfClusters + 1));
      if (ClusterList->Clusters == NULL)
      {
         printf("Error: realloc failed in CLUSTERLISTADT_AppendClusterToClusterList.\n");
         exit(1);
      }
   }

   ClusterList->NumberOfClusters += 1;
   CLUSTERADT_InitializeCluster(&(ClusterList->Clusters[ClusterList->NumberOfClusters - 1]), Sequence, SequenceIndex, DictionarySize, MaxNumberBasisSequences);
}
