/*****************************************************************/
/*  ELEC 999                                                     */
/*  University of Nebraska-Lincoln                               */
/*  Department of Electrical Engineering                         */
/*  David J. Russell                                             */
/*  3-5-10                                                       */
/*****************************************************************/

#ifdef _MATRIXDOUBLEADT
#define MATRIXDOUBLEADT_EXTERN
#else
#define MATRIXDOUBLEADT_EXTERN extern
#endif

/******************************************************************/
/* Public Module Constants                                        */
/******************************************************************/

/******************************************************************/
/* Public Type Definitions                                        */
/******************************************************************/
typedef struct
{
   DOUBLE *Cols;
} MATRIXDOUBLEADT_ROW_TYPE;

typedef struct
{
   ULONG NumRows;
   ULONG NumCols;
   MATRIXDOUBLEADT_ROW_TYPE *Rows;
} MATRIXDOUBLEADT_MATRIX_TYPE;

/*********************************************************************************/
/* Public Module Variables */
/*********************************************************************************/

/*********************************************************************************/
/* Public Module Function Prototypes */
/*********************************************************************************/

void MATRIXDOUBLEADT_InitializeMatrix(MATRIXDOUBLEADT_MATRIX_TYPE *Matrix, ULONG Rows, ULONG Cols);
void MATRIXDOUBLEADT_RedefineMatrix(MATRIXDOUBLEADT_MATRIX_TYPE *Matrix, ULONG Rows, ULONG Cols);
void MATRIXDOUBLEADT_CleanUpMatrix(MATRIXDOUBLEADT_MATRIX_TYPE *Matrix);
