/*****************************************************************/
/*  ELEC 999                                                     */
/*  University of Nebraska-Lincoln                               */
/*  Department of Electrical Engineering                         */
/*  David J. Russell                                             */
/*  3-5-10                                                       */
/*                                                               */
/* 8/24/10  - Removed the short sequence parameters, version 1.1 */
/* 9/24/10  - Added complete cluster searching, version 1.2      */
/* 9/27/10  - Added reverse complement checking, version 1.3     */
/*****************************************************************/

#ifdef _PARMS
#define PARMS_EXTERN
#else
#define PARMS_EXTERN extern
#endif

/*********************************************************************************/
/* Public Module Constants */
/*********************************************************************************/

/*********************************************************************************/
/* Public Type Definitions */
/*********************************************************************************/

/*********************************************************************************/
/* Public Module Variables */
/*********************************************************************************/

/*********************************************************************************/
/* Public Module Function Prototypes */
/*********************************************************************************/
BYTE *PARMS_GetInputFileName(void);
BYTE *PARMS_GetOutputFileName(void);
BYTE *PARMS_GetRepresentativeFileName(void);

UBYTE PARMS_GetFullBasisAmount(void);
FLOAT PARMS_GetGrammarDistanceIdenticalThreshold(void);
FLOAT PARMS_GetGrammarDistanceMaxThreshold(void);
FLOAT PARMS_GetGrammarDistanceCentroidMaxThreshold(void);
BOOLEAN PARMS_GetCompleteClusterSearch(void);
BOOLEAN PARMS_GetCheckReverseComplements(void);

BOOLEAN PARMS_ProcessCommandLine(INT argc, BYTE **argv);
void PARMS_Printf(BYTE *String);
